/* Figure definitions - figdefs.h */
/* Definition of the first three rotated positions of 
   the player's ship with no flame. */

int ships[16][16*4] = {
    { 0xFFFF, 0xFFFF, 0xFFFD, 0xFFFF, 0xFFFD, 0xFFFF,
      0xFFF8, 0xFFFF, 0xFFF8, 0xFFFF, 0xFFF2, 0x7FFF,
      0xFFF2, 0x7FFF, 0xFFF2, 0x7FFF, 0xFFE2, 0x3FFF,
      0xFFE2, 0x3FFF, 0xFFC2, 0x1FFF, 0xFFC2, 0x1FFF,
      0xFFC2, 0x1FFF, 0xFF82, 0x0FFF, 0xFF82, 0x0FFF,
      0xFF02, 0x07FF, 0xFF02, 0x07FF, 0xFF02, 0x07FF,
      0xFE02, 0x03FF, 0xFE02, 0x03FF, 0xFF02, 0x07FF,

// page 63
      0xFFC2, 0x1FFF, 0xFFF2, 0x7FFF, 0xFFFF, 0xFFFF, 
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF},
    { 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xEFFF, 
      0xFFFF, 0xCFFF, 0xFFFF, 0x8FFF, 0xFFFF, 0x2FFF, 
      0xFFFE, 0x2FFF, 0xFFFC, 0x4FFF, 0xFFF8, 0x4FFF, 
      0xFFF0, 0x8FFF, 0xFFE0, 0x8FFF, 0xFFC1, 0x0FFF, 
      0xFF81, 0x0FFF, 0xFF01, 0x0FFF, 0xFE02, 0x0FFF, 
      0xFC02, 0x0FFF, 0xFC04, 0x0FFF, 0xFC04, 0x0FFF,
      0xFE04, 0x0FFF, 0xFF08, 0x0FFF, 0xFF88, 0x0FFF,
      0xFFD0, 0x0FFF, 0xFFF0, 0x1FFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF},
    { 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
      0xFFFF, 0xF9FF, 0xFFFF, 0xE1FF, 0xFFFF, 0x0BFF, 
      0xFFFC, 0x13FF, 0xFFE0, 0x27FF, 0xFF80, 0x47FF, 
      0xFC00, 0x87FF, 0xF801, 0x0FFF, 0xF802, 0x0FFF, 
      0xFC04, 0x1FFF, 0xFC08, 0x1FFF, 0xFC10, 0x1FFF, 
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFE20, 0x3FFF,
      0xFE40, 0x3FFF, 0xFF80, 0x7FFF, 0xFF80, 0x7FFF,
      0xFFE0, 0x7FFF, 0xFFFC, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF},
};

/* First three rotated positions of the ship with a small
   flame */
int f1ships[16][16*4] = {
    { 0xFFFF, 0xFFFF, 0xFFFD, 0xFFFF, 0xFFFD, 0xFFFF, 
      0xFFF8, 0xFFFF, 0xFFF8, 0xFFFF, 0xFFF2, 0x7FFF, 
      0xFFF2, 0x7FFF, 0xFFF2, 0x7FFF, 0xFFE2, 0x3FFF, 
      0xFFE2, 0x3FFF, 0xFFC2, 0x1FFF, 0xFFC2, 0x1FFF, 
      0xFFC2, 0x1FFF, 0xFF82, 0x0FFF, 0xFF82, 0x0FFF, 
      0xFF02, 0x07FF, 0xFF02, 0x07FF, 0xFF02, 0x07FF, 
      0xFE02, 0x03FF, 0xFE02, 0x03FF, 0xFF02, 0x07FF, 
      0xFFC2, 0x1FFF, 0xFFF2, 0x7FFF, 0xFFFF, 0xFFFF, 
      0xFFEF, 0xBFFF, 0xFFF2, 0x7FFF, 0xFFF8, 0xFFFF, 
      0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF},

// page 64

    { 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xEFFF,
      0xFFFF, 0xCFFF, 0xFFFF, 0x8FFF, 0xFFFF, 0x2FFF,
      0xFFFE, 0x2FFF, 0xFFFC, 0x4FFF, 0xFFF8, 0x4FFF,
      0xFFF0, 0x8FFF, 0xFFE0, 0x8FFF, 0xFFC1, 0x0FFF,
      0xFF81, 0x0FFF, 0xFF01, 0x0FFF, 0xFE02, 0x0FFF,
      0xFC02, 0x0FFF, 0xFC04, 0x0FFF, 0xFC04, 0x0FFF,
      0xFE04, 0x0FFF, 0xFF08, 0x0FFF, 0xFF88, 0x0FFF,
      0xFED0, 0x0FFF, 0xFF70, 0x1FFF, 0xFF3F, 0xFFFF,
      0xFF81, 0xFFFF, 0xFF9F, 0xFFFF, 0xFFBF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF }, 
    { 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xF9FF, 0xFFFF, 0xE1FF, 0xFFFF, 0x0BFF,
      0xFFFC, 0x13FF, 0xFFE0, 0x27FF, 0xFF80, 0x47FF,
      0xFC00, 0x87FF, 0xF801, 0x0FFF, 0xF802, 0x0FFF,
      0xFC04, 0x1FFF, 0xFC08, 0x1FFF, 0xFC10, 0x1FFF,
      0xFE20, 0x3FFF, 0xFFFF, 0xFFFF, 0xFE20, 0x3FFF,
      0xFA40, 0x3FFF, 0xFB80, 0x7FFF, 0xFB80, 0x7FFF,
      0xF9E0, 0x7FFF, 0xF83C, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF},
    } ;

/* First three rotated positions of the ship with a Large
   flame */

int f2ships[16][16*4] = {
    { 0xFFFF, 0xFFFF, 0xFFFD, 0xFFFF, 0xFFFD, 0xFFFF, 
      0xFFF8, 0xFFFF, 0xFFF8, 0xFFFF, 0xFFF2, 0x7FFF, 
      0xFFF2, 0x7FFF, 0xFFF2, 0x7FFF, 0xFFE2, 0x3FFF, 
      0xFFE2, 0x3FFF, 0xFFC2, 0x1FFF, 0xFFC2, 0x1FFF, 
      0xFFC2, 0x1FFF, 0xFF82, 0x0FFF, 0xFF82, 0x0FFF, 
      0xFF02, 0x07FF, 0xFF02, 0x07FF, 0xFF02, 0x07FF, 
      0xFE02, 0x03FF, 0xFE02, 0x03FF, 0xFF02, 0x07FF, 
      0xFFC2, 0x1FFF, 0xFFF2, 0x7FFF, 0xFFBF, 0xEFFF, 
      0xFF9F, 0xCFFF, 0xFFCF, 0x9FFF, 0xFFC2, 0x1FFF, 
      0xFFE0, 0x3FFF, 0xFFF0, 0x7FFF, 0xFFF8, 0xFFFF, 
      0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF },
    { 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xEFFF,
      0xFFFF, 0xCFFF, 0xFFFF, 0x8FFF, 0xFFFF, 0x2FFF,
      0xFFFE, 0x2FFF, 0xFFFC, 0x4FFF, 0xFFF8, 0x4FFF,
      0xFFF0, 0x8FFF, 0xFFE0, 0x8FFF, 0xFFC1, 0x0FFF,

// page 64

      0xFF81, 0x0FFF, 0xFF01, 0x0FFF, 0xFE02, 0x0FFF,
      0xFC02, 0x0FFF, 0xFC04, 0x0FFF, 0xFC04, 0x0FFF,
      0xFE04, 0x0FFF, 0xFF08, 0x0FFF, 0xFD88, 0x0FFF,
      0xFCD0, 0x0FFF, 0xFCF0, 0x1FFF, 0xFCFF, 0xFFFF,
      0xFC7E, 0x7FFF, 0xFC60, 0xFFFF, 0xFE07, 0xFFFF,
      0xFE0F, 0xFFFF, 0xFE3F, 0xFFFF, 0xFEFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF },
    { 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xF9FF, 0xFFFF, 0xE1FF, 0xFFFF, 0x0BFF,
      0xFFFC, 0x13FF, 0xFFE0, 0x27FF, 0xFF80, 0x47FF,
      0xFC00, 0x87FF, 0xF801, 0x0FFF, 0xF802, 0x0FFF,
      0xFC04, 0x1FFF, 0xFC08, 0x1FFF, 0xF410, 0x1FFF,
      0xF620, 0x3FFF, 0xE640, 0x3FFF, 0xE780, 0x7FFF,
      0xE780, 0x7FFF, 0xE7E0, 0x7FFF, 0xC3FC, 0xFFFF,
      0xC00F, 0xFFFF, 0xC03F, 0xFFFF, 0xC3FF, 0xFFFF,
      0xBFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF },
    } ;

int small_meteor [] = {
      0xF1FF, 0xFFFF, 0xE07F, 0xFFFF, 0xD03F, 0xFFFF,
      0xA01F, 0xFFFF, 0xF41F, 0xFFFF, 0xA81F, 0xFFFF,
      0xD01F, 0xFFFF, 0xAA3F, 0xFFFF, 0xDDBF, 0xFFFF,
      0xF57F, 0xFFFF, 0xFAFF, 0xFFFF, 
    };

int medium_meteor[] = {
      0xFC0F, 0xFFFF, 0xFA04, 0x1FFF, 0xF502, 0x0FFF,
      0xF404, 0x07FF, 0xFA00, 0x03FF, 0xD540, 0x03FF,
      0xBAA0, 0x03FF, 0xFE40, 0x03FF, 0xBE20, 0x27FF,
      0xDD00, 0x4FFF, 0xFEB0, 0x27FF, 0xF740, 0x47FF,
      0xFEA0, 0x87FF, 0xFD48, 0x07FF, 0xEFA8, 0x0FFF,
      0xDD50, 0x1FFF, 0xEFA8, 0x3FFF, 0xFFF5, 0x7FFF,
      0xFAEA, 0xFFFF, 0xFF5F, 0xFFFF, 0xFFFF, 0xFFFF,
      0xFFFF, 0xFFFF
    };

int big_meteor[] = {
      0xffff, 0x83ff, 0xffff, 0xffff, 0x003f, 0xffff,
      0xfffc, 0x000f, 0xffff, 0xfff0, 0x0003, 0xffff,
      0xffc0, 0x0001, 0xffff, 0xff00, 0x0000, 0x0fff,
      0xfe80, 0x0000, 0x03ff, 0xfd40, 0x0000, 0x01ff,
      0xfa80, 0x0000, 0x00ff, 0xfd00, 0x0005, 0x00ff,


// page 65

      0xfa80, 0x0008, 0x007f, 0xf404, 0x0014, 0x007f,
      0xea04, 0x0008, 0x007f, 0xd508, 0x0010, 0x007f,
      0xbaa0, 0x0000, 0x007f, 0x5540, 0x0000, 0x013f,
      0xe880, 0x0000, 0x021f, 0x7440, 0x0000, 0x051f,
      0xba80, 0xa000, 0x029f, 0x7741, 0x0000, 0x055f,
      0xafaa, 0x0000, 0x00bf, 0x7544, 0x0010, 0x005f,
      0xeeaa, 0x08a8, 0x009f, 0x7575, 0x5140, 0x011f,
      0xeefa, 0xa0a0, 0x0a3f, 0x7d54, 0x5500, 0x147f,
      0xeaea, 0x2a80, 0x2a7f, 0x7d54, 0x0540, 0x1dff,
      0xfaea, 0x00a0, 0x3b7f, 0xfbda, 0x0055, 0x7f7f,
      0xffb5, 0x680a, 0xaaff, 0xffda, 0xb415, 0x75ff,
      0xffad, 0x6aaa, 0xabff, 0xf7d7, 0xd5d5, 0x57ff,
      0xfaee, 0xaab7, 0xafff, 0xfddd, 0x5e57, 0x7fff,
      0xfefe, 0xaebb, 0xffff, 0xffff, 0xd7ff, 0xffff,
      0xffab, 0xeeeb, 0xffff, 0xffd7, 0x7f57, 0xffff,
      0xfffe, 0xfeff, 0xffff, 0xffff, 0xffff, 0xffff,
      0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
      0xffff, 0xffff, 0xffff
    };

int small_shadowmask[] = {   /* small asteroid shadow mask */ 
      0x0e00, 0, 0x1f80, 0, 0x3fc0, 0, 0x7fe0, 0,
      0xffe0, 0, 0xffe0, 0, 0xffe0, 0, 0xffc0, 0,
      0xffc0, 0, 0x7f80, 0, 0x3f00, 0
    };

int medium_shadowmask[] = {
      0x03f0, 0x0000, 0x07ff, 0xe000, 0x0fff, 0xf000,
      0x0fff, 0xf800, 0x1fff, 0xfc00, 0x3fff, 0xfc00,
      0x7fff, 0xfc00, 0xffff, 0xfc00, 0xffff, 0xf800,
      0xffff, 0xf000, 0xffff, 0xfc00, 0xffff, 0xfc00,
      0x7fff, 0xfc00, 0x7fff, 0xfc00, 0x7fff, 0xf800,
      0x3fff, 0xf000, 0x3fff, 0xe000, 0x3fff, 0xc000,
      0x3fff, 0x8000, 0x1fff, 0x0000, 0x03e0, 0x0000,
      0x0000, 0x0000
    };

int big_shadowmask [] = {
      0x0000, 0x7c00, 0x0000, 0x0000, 0xffc0, 0x0000,
      0x0003, 0xfff0, 0x0000, 0x000f, 0xfffc, 0x0000,
      0x003f, 0xfffe, 0x0000, 0x00ff, 0xffff, 0xf000,
      0x01ff, 0xffff, 0xfc00, 0x03ff, 0xffff, 0xfe00,
      0x07ff, 0xffff, 0xff00, 0x07ff, 0xffff, 0xff00,
      0x0fff, 0xffff, 0xff80, 0x0fff, 0xffff, 0xff80,

// page 66

      0x1fff, 0xffff, 0xff80, 0x3fff, 0xffff, 0xff80, 
      0x7fff, 0xffff, 0xff80, 0xffff, 0xffff, 0xffc0, 
      0xffff, 0xffff, 0xffe0, 0xffff, 0xffff, 0xffe0, 
      0xffff, 0xffff, 0xffe0, 0xffff, 0xffff, 0xffe0, 
      0xffff, 0xffff, 0xffe0, 0xffff, 0xffff, 0xffe0, 
      0xffff, 0xffff, 0xffe0, 0xffff, 0xffff, 0xffe0, 
      0xffff, 0xffff, 0xffc0, 0xffff, 0xffff, 0xff80, 
      0xffff, 0xffff, 0xff80, 0xffff, 0xffff, 0xff80, 
      0x7fff, 0xffff, 0xff80, 0x7fff, 0xffff, 0xff80, 
      0x7fff, 0xffff, 0xff00, 0x3fff, 0xffff, 0xfe00,
      0x1fff, 0xffff, 0xfc00, 0x0fff, 0xffff, 0xf800,
      0x07ff, 0xffff, 0xf000, 0x03ff, 0xffff, 0xe000,
      0x01ff, 0xffff, 0x8000, 0x00ff, 0xffff, 0x0000,
      0x007f, 0xffff, 0x0000, 0x003f, 0xfffe, 0x0000,
      0x000f, 0xfff8, 0x0000
    };

short digits [] = {
      0xe7, 0xdb, 0xbd, 0xbd, 0xbd, 0xbd, 0xbd, 0xbd, 0xe7, /* 0 */
      0xef, 0xcf, 0xef, 0xef, 0xef, 0xef, 0xef, 0xef, 0xef, /* 1 */
      0xe3, 0xdd, 0xbd, 0xfd, 0xfb, 0xf7, 0xef, 0xdf, 0x81, /* 2 */
      0x81, 0xfb, 0xf7, 0xe7, 0xfb, 0xfd, 0xfd, 0xbb, 0xc7, /* 3 */
      0xfd, 0xf9, 0xf5, 0xed, 0xdd, 0xbd, 0x80, 0xfd, 0xfd, /* 4 */
      0x81, 0xbf, 0xbf, 0x83, 0xfd, 0xfd, 0xfd, 0xbd, 0xc3, /* 5 */
      0xe3, 0xdf, 0xbf, 0x83, 0xbd, 0xbd, 0xbd, 0xbd, 0xc3, /* 6 */
      0x81, 0xfd, 0xfb, 0xfb, 0xf7, 0xf7, 0xef, 0xef, 0xef, /* 7 */
      0xc3, 0xbd, 0xbd, 0xc3, 0xbd, 0xbd, 0xbd, 0xbd, 0xc3, /* 8 */
      0xc3, 0xbd, 0xbd, 0xbd, 0xbd, 0xc1, 0xfd, 0xfb, 0xc7  /* 9 */
    };

long alien[] = {
      0x00078000, 0x001fe000, 0x002ff000, 0x005ff800,
      0x002ff800, 0x0057f800, 0x00000000, 0x02d7ff00,
      0x05abff80, 0x0ad7fec0, 0x15efff60, 0x2bd7ffb0,
      0x55efff98, 0xabd7fffc, 0x00000000,
      0xcf3cf3cc, 0xcf3cf3cc, 0x4fccf3c8, 
      0x00078000, 0x001fe000, 0x002ff000, 0x005ff800,
      0x002ff800, 0x0057f800, 0x00000000, 0x02d7ff00,
      0x05abff80, 0x0ad7fec0, 0x15efff60, 0x2bd7ffb0,
      0x55efff98, 0xabd7fffc, 0x00000000,

// page 67

      0xf3cf3cf0, 0xf3cf3cf0, 0x73cf3cf0,
      0x00078000, 0x001fe000, 0x002ff000, 0x005ff800,
      0x002ff800, 0x0057f800, 0x00000000, 0x02d7ff00,
      0x05abff80, 0x0ad7fec0, 0x15efff60, 0x2bd7ffb0,
      0x55efff98, 0xabd7fffc, 0x00000000,
      0x3cf3cf3c, 0x3cf3cf3c, 0x3cf3cf38
    };

long small_alien[] = {
      0x07800000, 0x0fc00000, 0x0fc00000, 0x00000000,
      0x3ff00000, 0x5b680000,   /* windows */
      0xfffc0000, 0x00000000, 0x7ff80000, 0x1fe00000,
      0x07800000, 0x0fc00000, 0x0fc00000, 0x00000000,
      0x3ff00000, 0x6db00000,   /* windows */
      0xfffc0000, 0x00000000, 0x7ff80000, 0x1fe00000,
      0x07800000, 0x0fc00000, 0x0fc00000, 0x00000000,
      0x3ff00000, 0x36d80000,   /* windows */
      0xfffc0000, 0x00000000, 0x7ff80000, 0x1fe00000
    };
