/* Sound routines */

overlay "game"
/* Sound routines for Megaroids by Mitch Bunnell */
#define VBase (char *)0xefe1fe
#define SoundLow 0x7fd00
#define SndBufWLen 0x0172
extern long tickcount();
long old_tick;
int wsound; /*which sound is being played */
/* sound info for explosion sound */
char pamp1[] = { 20,128, 20,112, 20,96, 20,80, 20,64,
                 20,48, 30,32, 30,24, 30,16, 30,12, 30,8,
                 10,0, 0,0 } ;
char pl1[] = { 36,36,36,36,36,36,36,36,36,36,36,36,36,
               36,36,36,36,36,36,36,36,36,36,36,36,
               36,36,36,36,36,36,36,36,36,36,36,36,36
};
char sound_list[420];

/* fire sound */
char pamp2[] = { 85,64, 70,128, 58,64, 54,32, 48,32, 43,16,
                 39,8, 36,4, 30,2, 30,0, 0,0 } ;

// page 68

char pl2[] = { 8,9,10,11,12,13,14,15,16,17,18,19,20,21, 
               22,23,24,25,26,27,28,29,30};
char sound2_list[495];
/* big saucer sound */
char pl3[] = { 35,34,33,32,31,30,31,32,33,34,35};
char pamp3[] = { 125,200, 0,0 };
char sound3_list[125];
/* little saucer sound */
char pl4[] = { 15,14,13,12,11,10,11,12,13,14,15}; 
char pamp4[] = { 250,200, 70,200, 0,0 };
char sound4_list[320];
/* new ship sound */
char pl5[] = { 10,10,10,10,10,10,10,10,10,10,
               148,148,148,148,148,148,148,148,148,148, 
               10,10,10,10,10,10,10,10,10,10,
               148,148,148,148,148,148,148,148,148,148, 
               10,10,10,10,10,10,10,10,10,10 };
char pamp5[] ={170,255, 190,255, 35,0, 170,255, 190,255, 
               35,0, 170,255,200,255, 0,0 };
char sound5_list[1160];
/* low bomp sound */
char pamp6[] = { 6,128, 6,120, 6,112, 6,104, 6,96, 6,88,
                 6,80, 6,72, 6,64, 6,56, 6,48, 6,40, 6,32,
                 6,24, 6,16, 6,8, 0,0 };
char pl6[] = { 62,62,62,62,62,62,62,62,62,62,62,62,62,62,
               62,62 }; 
char sound6_list[230];
/* high bomp sound */
char pamp7[] = { 6,128, 6,120, 6,112, 6,104, 6,96, 6,88,
                 6,80, 6,72, 6,64, 6,56, 6,48, 6,40, 6,32,
                 6,24, 6,16, 6,8, 0,0 };
char pl7[] = { 60,60,60,60,60,60,60,60,60,60,60,60,60,60,
               60,60 }; 
char sound7_list[210];
/* sound list tables */
unsigned char *tblsound[] = { sound6_list, sound7_list,
  sound2_list, sound1_list, sound3_list, sound4_list,
  sound5_list };
unsigned char *tblpl[] = { pl6, pl7, pl2, pl1, pl3, pl4,
  pl5 };
int tblsize[] ={ sizeof(pl6), sizeof(pl7), sizeof(pl2),
  sizeof(pl1), sizeof(pl3), sizeof(pl4), sizeof(pl5)};

// page 69

unsigned char *tblpamp[] = { pamp6, pamp7, pamp2, pamp1,
  pamp3, pamp4, pamp5 };
unsigned tblpoly1[] = { 1,1,8, 0x4000,1,1,1 };
int period, pcount, oldv, running;
unsigned char *save_psound, *save_per;
unsigned randat;

init_sound() /* initialize sound */
{
  int i;
  i = wsound; /* rotate through sounds */
  save_per = tblpl[i];
  period = *save_per;
  pcount = period;
  save_psound = tblsound[i] + 1;
  oldv = *tblsound[i];
  running = tblsize[i];
}

rand(pcl) /* random number routine */
unsigned pcl;
{
  int t1, t2;
  if (pcl > 1) {
    t1 = randat;
    t2 = ((randat >>= 1) >> 1);
    if (!((t1 ^ t2) & 1)) randat |= pcl; 
    else randat &= ~pcl;
    return (randat & 0xff);
}

open_sound() /* open sound routine */
{
  int i,j, temp;
  unsigned char *pamp, *psound_list;

// page 70

  wsound = 0;
  for (i=0; i < sizeof(tblpamp)/4; i++) {
    pamp = tblpamp[i];
    psound_list = tblsound[i];
    randat = 87367;
    temp = 0;
    do {
      j = *pamp++;
      do {
        if (rand(tblpoly1[i]) & 1)
          *psound_list++ =
            (((temp = ~temp) & 0xff)*(int)*pamp)/0x100;
        else *psound_list++ = 0;
      } while (--j);
      pamp++;
    } while (*pamp);
  }
  running = 0;
  do_sound();
  /* clear sound list (because running is 0) */
  *VBase &= 0x7f; /* turn sound on */
{

do_sound() /* do the sound (call 1/60 sec) */
{
  if (running) { /* fill the sound buffer */
    period = *save_per++;
    asm {
        MOVE.L #SoundLow,A0       ; point to sound buffer
        MOVE #SndBufWLen-1, D0    ; get buffer Length
        MOVE.L save_psound(A4),A1 ; get pointer in sound list
        MOVE period(A4),D1        ; get period
        MOVE pcount(A4),D2        ; get period count
        MOVE oldv(A4),D3          ; get old volume
    LOOP:
        MOVE.B D3(A0)             ; repeat old amplitude
// page 71
        ADDQ #2,A0                ; point to next byte in sound buffer
        SUBQ #1, D2               ; decrement buffer counter
        DBEQ D0,LOOP              ; do for full buffer or end period
        BNE DONE                  ; if not end of period then done
        MOVE D1,D2                ; count else (period count=0)
                                  ; get next period
        MOVE.B (A1)+,D3           ; get save new amplitude as oldv
        DBF D0,LOOP               ; do till end of buffer
    DONE:
        MOVE.L A1,save_psound(A4) ; save spot in sound list
        MOVE D2,pcount (A4)       ; save period count
        MOVE D3,oldv(A4)          ; save old volume
    }
    --running;
  } /* else init-sound(); */
  else {
    asm {
       move.l #SoundLow,A0
       move #370-1, D0
    lp: clr.b (A0)
       addq #2, A0
       dbf D0, kp
    }
  }
}

close_sound()
{
  *VBase |= ~0x7f;
}

